import { renderless, api } from '@opentinyvue/vue-renderless/float-button/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import { iconLoading, iconClose } from '@opentinyvue/vue-icon';
import '@opentinyvue/vue-theme/float-button/index.css';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["click", "mouseout", "mouseover"],
  props: [].concat(props, ["type", "open", "description", "size", "icon", "resetTime", "tooltip", "loading", "disabled", "href", "target", "top", "bottom", "right", "left", "trigger", "shape", "backTop", "visibilityHeight", "element"]),
  components: {
    IconLoading: iconLoading(),
    IconClose: iconClose()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("button", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.show,
      expression: "state.show"
    }],
    ref: "tinyFloatButton",
    staticClass: "tiny-float-button",
    class: [_vm.type ? "tiny-float-button--" + _vm.type : "", _vm.size ? "tiny-float-button--" + _vm.size : "", {
      "is-disabled": _vm.state.buttonDisabled,
      "is-loading": _vm.loading,
      "is-icon": _vm.icon && !_vm.loading && (_vm.description || _vm.slots.default),
      "is-only-icon": _vm.icon && !_vm.loading && !(_vm.description || _vm.slots.default),
      "is-circle": _vm.shape === "circle",
      "is-square": _vm.shape === "square"
    }],
    style: {
      top: _vm.top,
      bottom: _vm.bottom,
      right: _vm.right,
      left: _vm.left
    },
    on: {
      "click": _vm.handleClick
    }
  }, [_vm.loading ? _c("icon-loading", {
    staticClass: "tiny-icon-loading tiny-svg-size"
  }) : _vm._e(), _vm.icon && !_vm.loading && !_vm.state.open ? _c(_vm.icon, {
    tag: "component",
    class: {
      "is-text": _vm.description || _vm.slots.default
    }
  }) : _vm._e(), !_vm.loading && _vm.state.open ? _c("icon-close") : _vm._e(), _vm.description && !_vm.state.open ? _c("div", [_vm._v(_vm._s(_vm.description))]) : _vm._e(), _vm.state.open ? _c("div", {
    ref: "tinyFloatButtonOpen",
    staticClass: "tiny-float-button--open"
  }, [_vm._t("default")], 2) : _vm._e()], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
